#include "../Helper/helperInclude.hpp"


/*


float matrioskaLoadVOT( string name, bool debug=false ) {

	Log::setLevel(0);
	
	//string queryBasePath = "F:/Value/Personal/Parthenope/Project/input/babenko/VOTChallenge/"+name+"/";
	string queryBasePath = "C:/VOT2014WD/sequences/"+name+"/";
	Matrioska mkv(queryBasePath + "%08d.jpg",queryBasePath + "groundtruth.txt");

	//mkv.outputPath = "F:/Value/Personal/Parthenope/Project/input/babenko/VOTChallenge/_outputMatrioska/";

	mkv.writeOutputVideo=false;

	//mkv.drawHoughVotes = true;
	mkv.setDebug(debug);

	//mkv.clearTechniquePool();
	//mkv.addMethodSURF();

	return mkv.run();
}




int mainVOT( int argc, char** argv ) {





	//testStatic();


	//matrioskaTest();

	/*
	mainVOT();
	return 0;

	/**/
	
	/*
	matrioskaLoadVOT( "bolt" ,true);
	sp();
	return 0;


	/**/
	
	/*
	vector<string> dataset;
	dataset.push_back("bicycle");
	dataset.push_back("bolt");
	dataset.push_back("car");
	dataset.push_back("cup");
	dataset.push_back("david");
	dataset.push_back("diving");
	dataset.push_back("face");
	dataset.push_back("gymnastics");
	dataset.push_back("hand");
	dataset.push_back("iceskater");
	dataset.push_back("juice");
	dataset.push_back("jump");
	dataset.push_back("singer");
	dataset.push_back("sunshade");
	dataset.push_back("torus");
	dataset.push_back("woman");

	ofstream outfile;
	outfile.open("F:/Value/Personal/Parthenope/Project/input/babenko/VOTChallenge/accuracy.txt",ios_base::app);
	outfile << endl<<endl<<"==== NEW RUN ==== "<<endl<<endl;

	vector<float> accuracy;
	for(auto d=0;d<dataset.size();d++) {
		float dAccuracy = matrioskaLoadVOT(dataset[d]);
		accuracy.push_back(dAccuracy);
		outfile << "Dataset: "<<dataset[d]<<", accuracy: "<<dAccuracy<<endl;
		cout << "Dataset: "<<dataset[d]<<", accuracy: "<<dAccuracy<<endl;
	}

	cout << "Mean Accuracy: "<< accumulate(accuracy.begin(), accuracy.end(), 0.0) / accuracy.size()<<endl;
	outfile << endl <<  "Mean Accuracy: "<< accumulate(accuracy.begin(), accuracy.end(), 0.0) / accuracy.size()<<endl;

	
	sp();
	
	
	return 0;

	
}




void runTemplate(string datasetName) {

	
	VideoCapture cap("F:/Value/Personal/Parthenope/Project/input/babenko/VOTChallenge/"+datasetName+"/%08d.jpg");
	GTManager gt;
	gt.open("F:/Value/Personal/Parthenope/Project/input/babenko/VOTChallenge/" + datasetName + "/groundtruth.txt");
	Rect firstBB = gt.getNextRect();

	while(1) {
		Mat frame;
		cap >> frame;

		
		if (frame.empty())
			break;

		ActiveTemplateMatching(frame, firstBB);

		waitKey(10);


	}
	

}
*/

void runSequencesMKV(vector<string> sequences = {}) {

	string datasetPath = "C:/VOT2014WD/sequences/";
	string outFile = "F:/Value/Personal/Parthenope/Project/input/babenko/VOTChallenge/_outputMatrioska/vot2014_mkv.txt";

	if (sequences.empty()) {

		sequences.push_back("ball");
		sequences.push_back("basketball");
		sequences.push_back("bicycle");
		sequences.push_back("bolt");
		sequences.push_back("car");
		sequences.push_back("david");
		sequences.push_back("diving");
		sequences.push_back("drunk");
		sequences.push_back("fernando");
		sequences.push_back("fish1");
		sequences.push_back("fish2");
		sequences.push_back("gymnastics");
		sequences.push_back("hand1");
		sequences.push_back("hand2");
		sequences.push_back("jogging");
		sequences.push_back("motocross");
		sequences.push_back("polarbear");
		sequences.push_back("skating");
		sequences.push_back("sphere");
		sequences.push_back("sunshade");
		sequences.push_back("surfing");
		sequences.push_back("torus");
		sequences.push_back("trellis");
		sequences.push_back("tunnel");
		sequences.push_back("woman");


	}

	vector<float> datasetAccuracy;

	fileAppend(outFile, "\n\n\n\n\n=====NEW RUN (accuracy)=====\n\n");

	for (auto& name : sequences) {

		Ptr<Tracker> tracker = new Matrioska();
		tracker->openDataset(datasetPath + name + "/");
		float accuracy = tracker->run();

		datasetAccuracy.push_back(accuracy);
		fileAppend(outFile, name + ": " + toString(accuracy) + "\n");
		waitKey(100);
	}

	string end = "\n===== FINAL MEAN ACCURACY: " + toString(meanVector<float>(datasetAccuracy)) + ", over " + toString(datasetAccuracy.size()) + " datasets\n";
	cout << end;
	fileAppend(outFile, end);

	sp();
}




int main(int argc, char *argv[]) {

	//runWebcam(new Matrioska()); return;

	runVOT(new Matrioska()); return 0;

	//runSequencesMKV();
	//return;

	
	Log::setLevel(0);
	Matrioska mkv;
	mkv.openDataset("C:/VOT2014WD/sequences/woman/");
	//mkv.gt.setOutputFile("F:/Value/Personal/Parthenope/Project/input/babenko/VOTChallenge/_outputMatrioska/output_matrioska.txt");
	float acc = mkv.run(0);

	cout << "Accuracy: " << acc << endl;
	sp();
	

	/*
	int startFrom=0;
	if (argc >= 2) {
		std::istringstream iss(argv[1]);
		iss >> startFrom;
	}
	Log::setLevel(2);
	Matrioska mkv;
	mkv.openDataset("./","input.avi","groundtruth.txt",GTManager::FORMAT_WH);
	//mkv.gt.setOutputFile("F:/Value/Personal/Parthenope/Project/input/babenko/VOTChallenge/_outputMatrioska/output_matrioska.txt");
	float acc = mkv.run(startFrom);
	sp();
	*/
	//runTemplate("car");

	//matrioskaLoadLTDTMotocross();

	//matrioskaLoadVOT("woman",true);

	return 0;
}
