#include "Matrioska/MatrioskaHeader.hpp"

int main(){

	VideoCapture video1("G:/LTDT/_outputMatrioska/without.avi");
	VideoCapture video2("G:/LTDT/_outputMatrioska/with.avi");
	VideoMaker outputVideo("G:/LTDT/_outputMatrioska/");

	int i=385;
	int j=750;

	int frameCount=0;

	while(true)  {
		frameCount++;
		
		
		Mat frame1, frame2, outputFrame;
		video1>>frame1;
		video2>>frame2;

		if (frame1.empty() || frame2.empty())
			break;

		outputFrame = Mat(frame1.rows,frame1.cols*2,frame1.type());

		frame1.copyTo(outputFrame(Rect(0,0,frame1.cols,frame1.rows)));
		frame2.copyTo(outputFrame(Rect(frame1.cols,0,frame2.cols,frame2.rows)));

		if ( frameCount>i && frameCount<j )
			outputVideo.writeFrame(outputFrame);

		showImage(outputFrame);
		waitKey(1);

	}

}